diff -Naur --exclude=CVS --exclude=configs linux/arch/i386/config.in linux-openmosix/arch/i386/config.in
--- linux/arch/i386/config.in	2003-11-28 19:26:19.000000000 +0100
+++ linux-openmosix/arch/i386/config.in	2004-04-06 21:16:50.000000000 +0200
@@ -10,6 +10,28 @@
 define_bool CONFIG_UID16 y
 
 mainmenu_option next_comment
+comment 'openMosix'
+bool 'openMosix process migration support' CONFIG_MOSIX
+if [ "$CONFIG_MOSIX" = "y" ]; then
+	bool 'Support clusters with a complex network topology' CONFIG_MOSIX_TOPOLOGY
+	if [ "$CONFIG_MOSIX_TOPOLOGY" = "y" ]; then
+	    int  'Maximum network-topology complexity to support (2-10)' CONFIG_MOSIX_MAXTOPOLOGY 4
+	fi
+
+	bool 'Stricter security on openMosix ports' CONFIG_MOSIX_SECUREPORTS
+	int  'Level of process-identity disclosure (0-3)' CONFIG_MOSIX_DISCLOSURE 1
+	#bool 'Create the kernel with a "-openmosix" extension' CONFIG_MOSIX_EXTMOSIX
+	bool 'openMosix File-System' CONFIG_MOSIX_FS
+	if [ "$CONFIG_MOSIX_FS" = "y" ]; then
+	   define_bool CONFIG_MOSIX_DFSA y
+	fi
+	bool 'Poll/Select exceptions on pipes' CONFIG_MOSIX_PIPE_EXCEPTIONS
+	bool 'Disable OOM Killer' CONFIG_MOSIX_NO_OOM
+	bool 'Load Limit' CONFIG_MOSIX_LOADLIMIT
+fi
+endmenu
+
+mainmenu_option next_comment
 comment 'Code maturity level options'
 bool 'Prompt for development and/or incomplete code/drivers' CONFIG_EXPERIMENTAL
 endmenu
diff -Naur --exclude=CVS --exclude=configs linux/arch/i386/kernel/entry.S linux-openmosix/arch/i386/kernel/entry.S
--- linux/arch/i386/kernel/entry.S	2003-06-13 16:51:29.000000000 +0200
+++ linux-openmosix/arch/i386/kernel/entry.S	2004-02-05 10:50:55.000000000 +0100
@@ -46,6 +46,10 @@
 #include <asm/segment.h>
 #include <asm/smp.h>
 
+#ifdef CONFIG_MOSIX
+#include "mosasm.H"
+#endif /* CONFIG_MOSIX */
+
 EBX		= 0x00
 ECX		= 0x04
 EDX		= 0x08
@@ -187,10 +191,16 @@
 	pushl %ebx
 	call SYMBOL_NAME(schedule_tail)
 	addl $4, %esp
+#ifdef CONFIG_MOSIX
+ENTRY(ret_from_kickstart)
+	GET_CURRENT(%ebx)
+	jmp	ret_from_sys_call
+#else
 	GET_CURRENT(%ebx)
 	testb $0x02,tsk_ptrace(%ebx)	# PT_TRACESYS
 	jne tracesys_exit
 	jmp	ret_from_sys_call
+#endif /* CONFIG_MOSIX */
 
 /*
  * Return to user mode is not as complex as all this looks,
@@ -207,14 +217,42 @@
 	jne tracesys
 	cmpl $(NR_syscalls),%eax
 	jae badsys
+#ifdef CONFIG_MOSIX
+	testl $(DTRACESYS1|DTRACESYS2),DFLAGS(%ebx)
+	jne adjust_trace_before_syscall
+adjusted_trace:
+	testb $DREMOTE,DFLAGS(%ebx)
+	je local_syscall
+on_remote:
+	pushl %eax
+	call *SYMBOL_NAME(remote_sys_call_table)(,%eax,4)
+	addl $4,%esp
+	movl %eax,EAX(%esp)
+	jmp ret_from_sys_call
+local_syscall:
+#endif /* CONFIG_MOSIX */
 	call *SYMBOL_NAME(sys_call_table)(,%eax,4)
 	movl %eax,EAX(%esp)		# save the return value
+#ifdef CONFIG_MOSIX
+	call SYMBOL_NAME(mosix_local_syscall)
+#endif /* CONFIG_MOSIX */
 ENTRY(ret_from_sys_call)
+#ifdef CONFIG_MOSIX
+	testl $(DTRACESYS1|DTRACESYS2),DFLAGS(%ebx)
+	jne adjust_trace_before_syscall
+ret_check_reschedule:
+#endif /* CONFIG_MOSIX */
 	cli				# need_resched and signals atomic test
 	cmpl $0,need_resched(%ebx)
 	jne reschedule
 	cmpl $0,sigpending(%ebx)
 	jne signal_return
+#ifdef CONFIG_MOSIX
+straight_to_mosix:
+	call SYMBOL_NAME(mosix_pre_usermode_actions)
+	testl %eax,%eax
+	jne ret_from_sys_call
+#endif /* CONFIG_MOSIX */
 restore_all:
 	RESTORE_ALL
 
@@ -226,7 +264,11 @@
 	jne v86_signal_return
 	xorl %edx,%edx
 	call SYMBOL_NAME(do_signal)
+#ifdef CONFIG_MOSIX
+	jmp straight_to_mosix
+#else
 	jmp restore_all
+#endif /* CONFIG_MOSIX */
 
 	ALIGN
 v86_signal_return:
@@ -234,18 +276,41 @@
 	movl %eax,%esp
 	xorl %edx,%edx
 	call SYMBOL_NAME(do_signal)
+#ifdef CONFIG_MOSIX
+	jmp straight_to_mosix
+#else
 	jmp restore_all
+#endif /* CONFIG_MOSIX */
 
 	ALIGN
 tracesys:
 	movl $-ENOSYS,EAX(%esp)
 	call SYMBOL_NAME(syscall_trace)
+#ifdef CONFIG_MOSIX
+adjust_trace_before_syscall:		# only arrive here with DTRACESYS(1|2)
+	testl $DDEPUTY,DFLAGS(%ebx)
+	jne straight_to_mosix		# no mess with signals/syscalls/tracesys
+	testl $DREMOTE,DFLAGS(%ebx)
+	je no_need_to_unsync
+	call wait_for_permission_to_continue
+no_need_to_unsync:
+	testl $DTRACESYS2,DFLAGS(%ebx)
+	jne second_tracesys		# skipping system-call
+	orl $DTRACESYS2,DFLAGS(%ebx)	# next time we skip the system-call
+	movl $-ENOSYS,EAX(%esp)
+	movl ORIG_EAX(%esp),%eax
+	cmpl $(NR_syscalls),%eax
+	jae second_tracesys		# prevent system-call out of range trick
+	jmp adjusted_trace		# now do the system-call
+second_tracesys:			# note: "syscall_trace" clears the flags
+#else
 	movl ORIG_EAX(%esp),%eax
 	cmpl $(NR_syscalls),%eax
 	jae tracesys_exit
 	call *SYMBOL_NAME(sys_call_table)(,%eax,4)
 	movl %eax,EAX(%esp)		# save the return value
 tracesys_exit:
+#endif /* CONFIG_MOSIX */
 	call SYMBOL_NAME(syscall_trace)
 	jmp ret_from_sys_call
 badsys:
@@ -259,7 +324,11 @@
 	movl EFLAGS(%esp),%eax		# mix EFLAGS and CS
 	movb CS(%esp),%al
 	testl $(VM_MASK | 3),%eax	# return to VM86 mode or non-supervisor?
+#ifdef CONFIG_MOSIX
+	jne ret_check_reschedule
+#else
 	jne ret_from_sys_call
+#endif /* CONFIG_MOSIX */
 	jmp restore_all
 
 	ALIGN
@@ -267,6 +336,73 @@
 	call SYMBOL_NAME(schedule)    # test
 	jmp ret_from_sys_call
 
+#ifdef CONFIG_MOSIX
+/*
+ * call_with_regs(caddr_t routine, pt_regs *before, pt_regs *after)
+ * pushes the "before" regs on the stack and calls routine,
+ * then places the possibly-modified registers in "after"
+ * (which may possibly equal "before").
+ * Also, set "current->altregs" to the pushed registers, then restores it.
+ */
+ENTRY(call_with_regs)
+	pushl	%ebx
+	GET_CURRENT(%ebx)
+	pushl	ALTREGS(%ebx)
+	movl	16(%esp),%eax
+	pushl	56(%eax)
+	pushl	52(%eax)
+	pushl	48(%eax)
+	pushl	44(%eax)
+	pushl	40(%eax)
+	pushl	36(%eax)
+	pushl	32(%eax)
+	pushl	28(%eax)
+	pushl	24(%eax)
+	pushl	20(%eax)
+	pushl	16(%eax)
+	pushl	12(%eax)
+	pushl	8(%eax)
+	pushl	4(%eax)
+	pushl	0(%eax)
+	movl	%esp,ALTREGS(%ebx)
+	movl	72(%esp),%eax
+	call	*%eax
+	movl	80(%esp),%edx
+	popl	%ecx
+	movl	%ecx,0(%edx)
+	popl	%ecx
+	movl	%ecx,4(%edx)
+	popl	%ecx
+	movl	%ecx,8(%edx)
+	popl	%ecx
+	movl	%ecx,12(%edx)
+	popl	%ecx
+	movl	%ecx,16(%edx)
+	popl	%ecx
+	movl	%ecx,20(%edx)
+	popl	%ecx
+	movl	%ecx,24(%edx)
+	popl	%ecx
+	movl	%ecx,28(%edx)
+	popl	%ecx
+	movl	%ecx,32(%edx)
+	popl	%ecx
+	movl	%ecx,36(%edx)
+	popl	%ecx
+	movl	%ecx,40(%edx)
+	popl	%ecx
+	movl	%ecx,44(%edx)
+	popl	%ecx
+	movl	%ecx,48(%edx)
+	popl	%ecx
+	movl	%ecx,52(%edx)
+	popl	%ecx
+	movl	%ecx,56(%edx)
+	popl	ALTREGS(%ebx)
+	popl	%ebx
+	ret
+#endif /* CONFIG_MOSIX */
+
 ENTRY(divide_error)
 	pushl $0		# no error code
 	pushl $ SYMBOL_NAME(do_divide_error)
@@ -410,7 +546,11 @@
 	.long SYMBOL_NAME(sys_read)
 	.long SYMBOL_NAME(sys_write)
 	.long SYMBOL_NAME(sys_open)		/* 5 */
+#ifdef CONFIG_MOSIX_DFSA
+	.long SYMBOL_NAME(sys_close_syscall)
+#else
 	.long SYMBOL_NAME(sys_close)
+#endif /* CONFIG_MOSIX_DFSA */
 	.long SYMBOL_NAME(sys_waitpid)
 	.long SYMBOL_NAME(sys_creat)
 	.long SYMBOL_NAME(sys_link)
diff -Naur --exclude=CVS --exclude=configs linux/arch/i386/kernel/i387.c linux-openmosix/arch/i386/kernel/i387.c
--- linux/arch/i386/kernel/i387.c	2003-08-25 13:44:39.000000000 +0200
+++ linux-openmosix/arch/i386/kernel/i387.c	2004-02-05 10:50:55.000000000 +0100
@@ -544,3 +544,66 @@
 
 	return fpvalid;
 }
+
+#ifdef CONFIG_MOSIX
+
+int
+has_fxsr(void)
+{
+	return(cpu_has_fxsr);
+}
+
+void
+fsave_to_fxsave(union i387_union *from, union i387_union *to)
+{
+	int i;
+	long *fcp, *tcp;
+
+	to->fxsave.cwd = from->fsave.cwd;
+	to->fxsave.swd = from->fsave.swd;
+	to->fxsave.twd = twd_i387_to_fxsr(from->fsave.twd);
+	to->fxsave.fop = from->fxsave.padding[0];
+	to->fxsave.fip = from->fsave.fip;
+	to->fxsave.fcs = from->fsave.fcs;
+	to->fxsave.foo = from->fsave.foo;
+	to->fxsave.mxcsr = from->fxsave.padding[1];
+	to->fxsave.fos = from->fsave.fos;
+	for(fcp = from->fsave.st_space , tcp = to->fxsave.st_space ,
+		i = 0 ; i < 8 ; i++)
+	{
+		*tcp++ = *fcp++;
+		*tcp++ = *fcp++;
+		*tcp = *((unsigned short *)fcp)++;
+		tcp += 2;
+	}
+	memcpy(to->fxsave.xmm_space, from->fxsave.xmm_space,
+						sizeof(from->fxsave.xmm_space));
+}
+
+void
+fxsave_to_fsave(union i387_union *from, union i387_union *to)
+{
+	int i;
+	long *fcp, *tcp;
+
+	to->fsave.cwd = from->fxsave.cwd;
+	to->fsave.swd = from->fxsave.swd;
+	to->fsave.twd = twd_fxsr_to_i387(&from->fxsave);
+	to->fsave.fip = from->fxsave.fip;
+	to->fsave.fcs = from->fxsave.fcs;
+	to->fsave.foo = from->fxsave.foo;
+	to->fsave.fos = from->fxsave.fos;
+	to->fxsave.padding[0] = from->fxsave.fop;
+	to->fxsave.padding[1] = from->fxsave.mxcsr;
+	for(fcp = from->fxsave.st_space , tcp = to->fsave.st_space ,
+		i = 0 ; i < 8 ; i++)
+	{
+		*tcp++ = *fcp++;
+		*tcp++ = *fcp++;
+		*((unsigned short *)tcp)++ = *fcp;
+		fcp += 2;
+	}
+	memcpy(to->fxsave.xmm_space, from->fxsave.xmm_space,
+						sizeof(to->fxsave.xmm_space));
+}
+#endif /* CONFIG_MOSIX */
diff -Naur --exclude=CVS --exclude=configs linux/arch/i386/kernel/ioport.c linux-openmosix/arch/i386/kernel/ioport.c
--- linux/arch/i386/kernel/ioport.c	2003-06-13 16:51:29.000000000 +0200
+++ linux-openmosix/arch/i386/kernel/ioport.c	2004-02-05 10:50:55.000000000 +0100
@@ -15,6 +15,10 @@
 #include <linux/smp_lock.h>
 #include <linux/stddef.h>
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
+
 /* Set EXTENT bits starting at BASE in BITMAP to value TURN_ON. */
 static void set_bitmap(unsigned long *bitmap, short base, short extent, int new_value)
 {
@@ -61,6 +65,10 @@
 		return -EINVAL;
 	if (turn_on && !capable(CAP_SYS_RAWIO))
 		return -EPERM;
+#ifdef CONFIG_MOSIX
+	if(turn_on && !mosix_go_home_for_reason(1, DSTAY_FOR_IOPL))
+		return(-ENOMEM);
+#endif /* CONFIG_MOSIX */
 	/*
 	 * If it's the first ioperm() call in this thread's lifetime, set the
 	 * IO bitmap up. ioperm() is much less timing critical than clone(),
@@ -112,6 +120,11 @@
 		if (!capable(CAP_SYS_RAWIO))
 			return -EPERM;
 	}
+#ifdef CONFIG_MOSIX
+	if(!mosix_go_home_for_reason(1, DSTAY_FOR_IOPL))
+		return(-ENOMEM);
+	regs = mos_to_regs(&current->mosix);
+#endif /* CONFIG_MOSIX */
 	regs->eflags = (regs->eflags & 0xffffcfff) | (level << 12);
 	return 0;
 }
diff -Naur --exclude=CVS --exclude=configs linux/arch/i386/kernel/Makefile linux-openmosix/arch/i386/kernel/Makefile
--- linux/arch/i386/kernel/Makefile	2003-11-28 19:26:19.000000000 +0100
+++ linux-openmosix/arch/i386/kernel/Makefile	2004-02-05 10:50:55.000000000 +0100
@@ -45,3 +45,14 @@
 obj-$(CONFIG_EDD)             	+= edd.o
 
 include $(TOPDIR)/Rules.make
+
+ifdef CONFIG_MOSIX
+entry.o: ./mosasm.H
+
+offset: offset.c $(TOPDIR)/include/linux/config.h $(TOPDIR)/include/linux/types.h $(TOPDIR)/include/linux/sched.h $(TOPDIR)/include/linux/signal.h $(TOPDIR)/include/linux/sys.h $(TOPDIR)/include/linux/kernel.h
+	$(HOSTCC) $(HOSTCFLAGS) -D__KERNEL__ -I$(TOPDIR)/include -o offset offset.c
+
+./mosasm.H: offset entry.S
+	./offset < entry.S > mosasm.H
+
+endif
diff -Naur --exclude=CVS --exclude=configs linux/arch/i386/kernel/process.c linux-openmosix/arch/i386/kernel/process.c
--- linux/arch/i386/kernel/process.c	2003-11-28 19:26:19.000000000 +0100
+++ linux-openmosix/arch/i386/kernel/process.c	2004-02-05 10:50:55.000000000 +0100
@@ -52,6 +52,10 @@
 
 #include <linux/irq.h>
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
+
 asmlinkage void ret_from_fork(void) __asm__("ret_from_fork");
 
 int hlt_counter;
@@ -163,6 +167,8 @@
 /* shamelessly grabbed from lib/vsprintf.c for readability */
 #define is_digit(c)	((c) >= '0' && (c) <= '9')
 #endif
+
+
 static int __init reboot_setup(char *str)
 {
 	while(1) {
@@ -522,6 +528,43 @@
 	return retval;
 }
 
+#ifdef CONFIG_MOSIX
+/*
+ * Create a thread that starts as kernel, but will eventually run in user-mode:
+ * The slight differences from "kernel_thread" are:
+ * 1) not using CLONE_VM.
+ * 2) adding SIGCHLD to the flags.
+ * 3) leaving space on the stack for the user-registers.
+ */
+int arch_user_thread(int (*fn)(void *), void * arg, unsigned long flags)
+{
+	long retval, d0;
+
+	__asm__ __volatile__(
+		"movl %%esp,%%esi\n\t"
+		"int $0x80\n\t"		/* Linux/i386 system call */
+		"cmpl %%esp,%%esi\n\t"	/* child or parent? */
+		"je 1f\n\t"		/* parent - jump */
+		"subl %7,%%esp\n\t"	/* space for user-registers */
+		/* Load the argument into eax, and push it.  That way, it does
+		 * not matter whether the called function is compiled with
+		 * -mregparm or not.  */
+		"movl %4,%%eax\n\t"
+		"pushl %%eax\n\t"		
+		"call *%5\n\t"		/* call fn */
+		"movl %3,%0\n\t"	/* exit */
+		"int $0x80\n"
+		"1:\t"
+		:"=&a" (retval), "=&S" (d0)
+		:"0" (__NR_clone), "i" (__NR_exit),
+		 "r" (arg), "r" (fn),
+		 "b" (flags | SIGCHLD),
+		 "i" (sizeof(struct pt_regs))
+		: "memory");
+	return retval;
+}
+#endif /* CONFIG_MOSIX */
+
 /*
  * Free current thread data structures etc..
  */
@@ -597,6 +640,10 @@
 
 	childregs = ((struct pt_regs *) (THREAD_SIZE + (unsigned long) p)) - 1;
 	struct_cpy(childregs, regs);
+#ifdef CONFIG_MOSIX
+	p->mosix.altregs = (uint32_t *)childregs;
+	p->mosix.deputy_regs = current->mosix.deputy_regs;
+#endif /* CONFIG_MOSIX */
 	childregs->eax = 0;
 	childregs->esp = esp;
 
@@ -748,10 +795,32 @@
 			 */
 			tss->bitmap = INVALID_IO_BITMAP_OFFSET;
 	}
+#ifdef CONFIG_MOSIX
+	if(test_bit(X86_FEATURE_TSC, &boot_cpu_data.x86_capability))
+	{
+		/* REMOTE emulates the RDTSC instruction */
+		if(next_p->mosix.dflags & DREMOTE)
+		{
+			if(!(prev_p->mosix.dflags & DREMOTE))
+				__asm__ __volatile__("movl %%cr4,%%eax\n\t" \
+					"orl $4,%%eax\n\t" \
+					"movl %%eax,%%cr4\n" \
+					: : :"ax");
+		}
+		else if(prev_p->mosix.dflags & DREMOTE)
+			__asm__ __volatile__("movl %%cr4,%%eax\n\t" \
+				"andl $0xfffffffb,%%eax\n\t" \
+				"movl %%eax,%%cr4\n" \
+				: : :"ax");
+	}
+#endif /* CONFIG_MOSIX */
 }
 
 asmlinkage int sys_fork(struct pt_regs regs)
 {
+#ifdef CONFIG_MOSIX
+	mosix_obtain_registers(BIT_OF_REGISTER(esp));
+#endif /* CONFIG_MOSIX */
 	return do_fork(SIGCHLD, regs.esp, &regs, 0);
 }
 
@@ -759,12 +828,27 @@
 {
 	unsigned long clone_flags;
 	unsigned long newsp;
+#ifdef CONFIG_MOSIX
+	int retval;
+#endif /* CONFIG_MOSIX */
 
 	clone_flags = regs.ebx;
 	newsp = regs.ecx;
 	if (!newsp)
+#ifdef CONFIG_MOSIX
+		mosix_obtain_registers(BIT_OF_REGISTER(esp)) ,
+#endif /* CONFIG_MOSIX */
 		newsp = regs.esp;
+#ifdef CONFIG_MOSIX
+	if((clone_flags & CLONE_VM) && (retval = mosix_pre_clone()))
+		return(retval);
+	retval = do_fork(clone_flags, newsp, &regs, 0);
+	if(clone_flags & CLONE_VM)
+		mosix_post_clone();
+	return(retval);
+#else
 	return do_fork(clone_flags, newsp, &regs, 0);
+#endif /* CONFIG_MOSIX */
 }
 
 /*
@@ -779,7 +863,18 @@
  */
 asmlinkage int sys_vfork(struct pt_regs regs)
 {
+#ifdef CONFIG_MOSIX
+	int retval;
+
+	mosix_obtain_registers(BIT_OF_REGISTER(esp));
+	if((retval = mosix_pre_clone()))
+		return(retval);
+	retval = do_fork(CLONE_VFORK | CLONE_VM | SIGCHLD, regs.esp, &regs, 0);
+	mosix_post_clone();
+	return(retval);
+#else
 	return do_fork(CLONE_VFORK | CLONE_VM | SIGCHLD, regs.esp, &regs, 0);
+#endif /* CONFIG_MOSIX */
 }
 
 /*
@@ -815,23 +910,50 @@
 	unsigned long ebp, esp, eip;
 	unsigned long stack_page;
 	int count = 0;
+#ifdef CONFIG_MOSIX
+	unsigned long result = 0;
+	if (!p || p == current || LOGICAL_STATE(p) == TASK_RUNNING)
+#else
 	if (!p || p == current || p->state == TASK_RUNNING)
+#endif /* CONFIG_MOSIX */
 		return 0;
 	stack_page = (unsigned long)p;
 	esp = p->thread.esp;
 	if (!stack_page || esp < stack_page || esp > 8188+stack_page)
+#ifdef CONFIG_MOSIX
+		return(result);
+#else
 		return 0;
+#endif /* CONFIG_MOSIX */
 	/* include/asm-i386/system.h:switch_to() pushes ebp last. */
 	ebp = *(unsigned long *) esp;
 	do {
 		if (ebp < stack_page || ebp > 8184+stack_page)
+#ifdef CONFIG_MOSIX
+			return(result);
+#else
 			return 0;
+#endif /* CONFIG_MOSIX */
 		eip = *(unsigned long *) (ebp+4);
 		if (eip < first_sched || eip >= last_sched)
+#ifdef CONFIG_MOSIX
+		{
+			if(!result)
+				return eip;
+		}
+		else
+			result = 0;
+#else
 			return eip;
+#endif /* CONFIG_MOSIX */
 		ebp = *(unsigned long *) ebp;
+#ifdef CONFIG_MOSIX
+	} while (count++ < 64);
+	return(result);
+#else
 	} while (count++ < 16);
 	return 0;
+#endif /* CONFIG_MOSIX */
 }
 #undef last_sched
 #undef first_sched
diff -Naur --exclude=CVS --exclude=configs linux/arch/i386/kernel/ptrace.c linux-openmosix/arch/i386/kernel/ptrace.c
--- linux/arch/i386/kernel/ptrace.c	2002-08-03 02:39:42.000000000 +0200
+++ linux-openmosix/arch/i386/kernel/ptrace.c	2004-02-05 10:50:55.000000000 +0100
@@ -21,6 +21,10 @@
 #include <asm/i387.h>
 #include <asm/debugreg.h>
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
+
 /*
  * does not yet catch signals sent when the child dies.
  * in exit.c or in signal.c.
@@ -44,13 +48,47 @@
  * this routine assumes that all the privileged stacks are in our
  * data space.
  */   
+#ifdef CONFIG_MOSIX
+inline int get_stack_long(struct task_struct *task, int offset)
+#else
 static inline int get_stack_long(struct task_struct *task, int offset)
+#endif /* CONFIG_MOSIX */
 {
 	unsigned char *stack;
 
+#ifdef CONFIG_MOSIX
+	if(task != current)
+		lock_mosix();
+	if(task->mosix.dflags & DDEPUTY)
+	{
+		if(task != current)
+			unlock_mosix();
+		return(request_process(task, NULL, PR_PTRACE_GET_STACK_LONG,
+			offset));
+	}
+	if(task == current)
+		mosix_obtain_registers(ALL_REGISTERS);
+	else
+		task_lock(task);
+	if(!task->thread.saved_esp0)	/* unless in VM86 mode */
+		stack = (char *)(mos_to_regs(&task->mosix) + 1);
+	else
+#endif /* CONFIG_MOSIX */
 	stack = (unsigned char *)task->thread.esp0;
 	stack += offset;
+#ifdef CONFIG_MOSIX
+	{
+		int res = *((int *)stack);
+		if(task != current)
+		{
+			task_unlock(task);
+			unlock_mosix();
+		}
+		return(res);
+	}
+#else
 	return (*((int *)stack));
+#endif /* CONFIG_MOSIX */
 }
 
 /*
@@ -59,14 +97,43 @@
  * this routine assumes that all the privileged stacks are in our
  * data space.
  */
+#ifdef CONFIG_MOSIX
+inline int put_stack_long(struct task_struct *task, int offset,
+#else
 static inline int put_stack_long(struct task_struct *task, int offset,
+#endif /* CONFIG_MOSIX */
 	unsigned long data)
 {
 	unsigned char * stack;
 
+#ifdef CONFIG_MOSIX
+	if(task != current)
+		lock_mosix();
+	if(task->mosix.dflags & DDEPUTY)
+	{
+		if(task != current)
+			unlock_mosix();
+		return(request_process_arg2(task, NULL,
+			PR_PTRACE_PUT_STACK_LONG, offset, data));
+	}
+	if(task == current)
+		mosix_obtain_registers(ALL_REGISTERS);
+	else
+		task_lock(task);
+	if(!task->thread.saved_esp0)	/* unless in VM86 mode */
+		stack = (char *)(mos_to_regs(&task->mosix) + 1);
+	else
+#endif /* CONFIG_MOSIX */
 	stack = (unsigned char *) task->thread.esp0;
 	stack += offset;
 	*(unsigned long *) stack = data;
+#ifdef CONFIG_MOSIX
+	if(task != current)
+	{
+		task_unlock(task);
+		unlock_mosix();
+	}
+#endif /* CONFIG_MOSIX */
 	return 0;
 }
 
@@ -107,6 +174,17 @@
 	return 0;
 }
 
+#ifdef CONFIG_MOSIX
+void
+ptrace_putregs(unsigned long *data)
+{
+	register int i;
+
+	for (i = 0; i < FRAME_SIZE ; i++)
+		putreg(current, i << 2, data[i]);
+}
+#endif /* CONFIG_MOSIX */
+
 static unsigned long getreg(struct task_struct *child,
 	unsigned long regno)
 {
@@ -147,6 +225,17 @@
 	put_stack_long(child, EFL_OFFSET, tmp);
 }
 
+#ifdef CONFIG_MOSIX
+void
+ptrace_getregs(unsigned long *data)
+{
+	register int i;
+
+	for (i = 0; i < FRAME_SIZE ; i++)
+		data[i] = getreg(current, i << 2);
+}
+#endif /* CONFIG_MOSIX */
+
 asmlinkage int sys_ptrace(long request, long pid, long addr, long data)
 {
 	struct task_struct *child;
@@ -161,6 +250,9 @@
 			goto out;
 		/* set the ptrace bit in the process flags. */
 		current->ptrace |= PT_PTRACED;
+#ifdef CONFIG_MOSIX_DFSA
+		tell_process(current, DREQ_NOTUPTODATE);
+#endif /* CONFIG_MOSIX_DFSA */
 		ret = 0;
 		goto out;
 	}
@@ -210,6 +302,17 @@
 		    addr > sizeof(struct user) - 3)
 			break;
 
+#ifdef CONFIG_MOSIX
+		lock_mosix();
+		if(child->mosix.dflags & DDEPUTY)
+		{
+			unlock_mosix();
+			if(request_process(child, &tmp, PR_PTRACE_PEEKUSER, addr))
+				goto out;
+		}
+		else
+		{
+#endif /* CONFIG_MOSIX */
 		tmp = 0;  /* Default return condition */
 		if(addr < FRAME_SIZE*sizeof(long))
 			tmp = getreg(child, addr);
@@ -219,6 +322,10 @@
 			addr = addr >> 2;
 			tmp = child->thread.debugreg[addr];
 		}
+#ifdef CONFIG_MOSIX
+		unlock_mosix();
+		}
+#endif /* CONFIG_MOSIX */
 		ret = put_user(tmp,(unsigned long *) data);
 		break;
 	}
@@ -265,7 +372,23 @@
 
 			  addr -= (long) &dummy->u_debugreg;
 			  addr = addr >> 2;
+#ifdef CONFIG_MOSIX
+			  lock_mosix();
+			  if(child->mosix.dflags & DDEPUTY)
+			  {
+				unlock_mosix();
+				if(request_process_arg2(child, NULL,
+					PR_PTRACE_POKEUSER, addr, data))
+					goto out;
+			  }
+			  else
+			  {
+#endif /* CONFIG_MOSIX */
 			  child->thread.debugreg[addr] = data;
+#ifdef CONFIG_MOSIX
+			  unlock_mosix();
+			  }
+#endif /* CONFIG_MOSIX */
 			  ret = 0;
 		  }
 		  break;
@@ -282,9 +405,22 @@
 		else
 			child->ptrace &= ~PT_TRACESYS;
 		child->exit_code = data;
+#ifdef CONFIG_MOSIX
+		if(child->mosix.dflags & DDEPUTY)
+		{
+			if(request_process(child, NULL, PR_PTRACE_CONT,
+								request))
+				goto out;
+		}
+		else
+		{
+#endif /* CONFIG_MOSIX */
 	/* make sure the single step bit is not set. */
 		tmp = get_stack_long(child, EFL_OFFSET) & ~TRAP_FLAG;
 		put_stack_long(child, EFL_OFFSET,tmp);
+#ifdef CONFIG_MOSIX
+		}
+#endif /* CONFIG_MOSIX */
 		wake_up_process(child);
 		ret = 0;
 		break;
@@ -299,7 +435,11 @@
 		long tmp;
 
 		ret = 0;
+#ifdef CONFIG_MOSIX
+		if (LOGICAL_STATE(child) == TASK_ZOMBIE) /* already dead */
+#else
 		if (child->state == TASK_ZOMBIE)	/* already dead */
+#endif /* CONFIG_MOSIX */
 			break;
 		child->exit_code = SIGKILL;
 		/* make sure the single step bit is not set. */
@@ -320,8 +460,21 @@
 			/* Spurious delayed TF traps may occur */
 			child->ptrace |= PT_DTRACE;
 		}
+#ifdef CONFIG_MOSIX
+		if(child->mosix.dflags & DDEPUTY)
+		{
+			if(request_process(child, NULL, PR_PTRACE_SINGLE_STEP,
+									0))
+				goto out;
+		}
+		else
+		{
+#endif /* CONFIG_MOSIX */
 		tmp = get_stack_long(child, EFL_OFFSET) | TRAP_FLAG;
 		put_stack_long(child, EFL_OFFSET, tmp);
+#ifdef CONFIG_MOSIX
+		}
+#endif /* CONFIG_MOSIX */
 		child->exit_code = data;
 		/* give it a chance to run. */
 		wake_up_process(child);
@@ -339,26 +492,57 @@
 			ret = -EIO;
 			break;
 		}
+#ifdef CONFIG_MOSIX
+		/* NOTE: even when child does not look like a DEPUTY,
+		 * it could easily become one while we wait for a page
+		 * on __put_user ... therefore, we do this ALWAYS:
+		 */
+		{
+			unsigned long t[FRAME_SIZE];
+
+			if(request_process(child, &t, PR_PTRACE_GETREGS, 0))
+				ret = -EIO;
+			else
+				copy_to_user((void *)data, t, sizeof(t));
+		}
+#else
 		for ( i = 0; i < FRAME_SIZE*sizeof(long); i += sizeof(long) ) {
 			__put_user(getreg(child, i),(unsigned long *) data);
 			data += sizeof(long);
 		}
+#endif /* CONFIG_MOSIX */
 		ret = 0;
 		break;
 	}
 
 	case PTRACE_SETREGS: { /* Set all gp regs in the child. */
+#ifndef CONFIG_MOSIX
 		unsigned long tmp;
+#endif /* CONFIG_MOSIX */
 	  	if (!access_ok(VERIFY_READ, (unsigned *)data, FRAME_SIZE*sizeof(long))) {
 			ret = -EIO;
 			break;
 		}
+#ifdef CONFIG_MOSIX
+		/* NOTE: even when child does not look like a DEPUTY,
+		 * it could easily become one while we wait for a page
+		 * on __get_user ... therefore, we do this ALWAYS:
+		 */
+		{
+			unsigned long t[FRAME_SIZE];
+
+			copy_from_user(t, (void *)data, sizeof(t));
+			ret = request_process(child, &t, PR_PTRACE_SETREGS, 0)
+								? -EIO : 0;
+		}
+#else
 		for ( i = 0; i < FRAME_SIZE*sizeof(long); i += sizeof(long) ) {
 			__get_user(tmp, (unsigned long *) data);
 			putreg(child, i, tmp);
 			data += sizeof(long);
 		}
 		ret = 0;
+#endif /* CONFIG_MOSIX */
 		break;
 	}
 
@@ -369,9 +553,27 @@
 			break;
 		}
 		ret = 0;
+#ifdef CONFIG_MOSIX
+		/* DEPUTY or NOT - the child-process may become DEPUTY
+		 * while we page-fault on "__copy_to_user",
+		 * so we always do it the long way:
+		 */
+		{
+			struct user_i387_struct f;
+
+			if(request_process(child, &f, PR_PTRACE_GETFPREGS, 0))
+			{
+				ret = -EIO;
+				goto out;
+			}
+			__copy_to_user((void *)data, &f,
+				sizeof(struct user_i387_struct));
+		}
+#else
 		if ( !child->used_math )
 			load_empty_fpu(child);
 		get_fpregs((struct user_i387_struct *)data, child);
+#endif /* CONFIG_MOSIX */
 		break;
 	}
 
@@ -381,9 +583,23 @@
 			ret = -EIO;
 			break;
 		}
+#ifdef CONFIG_MOSIX
+		/* DEPUTY or NOT - the child-process may become DEPUTY
+		 * while we page-fault on "__copy_from_user",
+		 * so we always do it the long way:
+		 */
+		{
+			struct user_i387_struct f;
+
+			__copy_from_user(&f, (void *)data, sizeof(f));
+			ret = request_process(child, &f, PR_PTRACE_SETFPREGS, 0)
+								? -EIO : 0;
+		}
+#else
 		child->used_math = 1;
 		set_fpregs(child, (struct user_i387_struct *)data);
 		ret = 0;
+#endif /* CONFIG_MOSIX */
 		break;
 	}
 
@@ -393,9 +609,28 @@
 			ret = -EIO;
 			break;
 		}
+#ifdef CONFIG_MOSIX
+		ret = 0;
+		/* DEPUTY or NOT - the child-process may become DEPUTY
+		 * while we page-fault on "__copy_to_user",
+		 * so we always do it the long way:
+		 */
+		{
+			struct user_fxsr_struct f;
+
+			if(request_process(child, &f, PR_PTRACE_GETFPXREGS, 0))
+			{
+				ret = -EIO;
+				goto out;
+			}
+			__copy_to_user((void *)data, &f,
+				sizeof(struct user_fxsr_struct));
+		}
+#else
 		if ( !child->used_math )
 			load_empty_fpu(child);
 		ret = get_fpxregs((struct user_fxsr_struct *)data, child);
+#endif /* CONFIG_MOSIX */
 		break;
 	}
 
@@ -405,8 +640,22 @@
 			ret = -EIO;
 			break;
 		}
+#ifdef CONFIG_MOSIX
+		/* DEPUTY or NOT - the child-process may become DEPUTY
+		 * while we page-fault on "__copy_from_user",
+		 * so we always do it the long way:
+		 */
+		{
+			struct user_fxsr_struct f;
+
+			__copy_from_user(&f, (void *)data, sizeof(f));
+			ret = request_process(child, &f, PR_PTRACE_SETFPXREGS,
+								0) ? -EIO : 0;
+		}
+#else
 		child->used_math = 1;
 		ret = set_fpxregs(child, (struct user_fxsr_struct *)data);
+#endif /* CONFIG_MOSIX */
 		break;
 	}
 
@@ -430,7 +679,163 @@
 	return ret;
 }
 
+#ifdef CONFIG_MOSIX
+/*
+ * The following routines are parts of sys_ptrace performed by the
+ * child process on itself.
+ * Should the relevant code in "sys_ptrace" change, the following routines
+ * must also be modified accordingly.
+ */
+unsigned long
+ptrace_peekuser(long addr)
+{
+	struct user * dummy = NULL;
+	unsigned long tmp;
+
+	tmp = 0;  /* Default return condition */
+	if(addr < FRAME_SIZE*sizeof(long))
+		tmp = getreg(current, addr);
+	if(addr >= (long) &dummy->u_debugreg[0] &&
+	   addr <= (long) &dummy->u_debugreg[7]){
+		addr -= (long) &dummy->u_debugreg[0];
+		addr = addr >> 2;
+		tmp = current->thread.debugreg[addr];
+	};
+	return(tmp);
+}
+
+void
+ptrace_pokeuser(long addr, long data)
+{
+	current->thread.debugreg[addr] = data;
+#define loaddebug(tsk,register) \
+		__asm__("movl %0,%%db" #register  \
+			: /* no output */ \
+			:"r" (tsk->thread.debugreg[register]))
+	/* unlike the original ptrace code, we are doing this for ourselves,
+	 * and there may be no "switch_to" before we go to user-mode again,
+	 * so here we go:
+	 */
+	if(current->thread.debugreg[7])
+	{
+		loaddebug(current, 0);
+		loaddebug(current, 1);
+		loaddebug(current, 2);
+		loaddebug(current, 3);
+		loaddebug(current, 6);
+		loaddebug(current, 7);
+	}
+}
+
+void
+ptrace_cont(int request)
+{
+	unsigned long tmp;
+	struct task_struct *tsk = current;
+
+	tmp = get_stack_long(tsk, EFL_OFFSET) & ~TRAP_FLAG;
+	put_stack_long(tsk, EFL_OFFSET, tmp);
+	if (request == PTRACE_SYSCALL)
+		tsk->ptrace |= PT_TRACESYS;
+	else
+		tsk->ptrace &= ~PT_TRACESYS;
+	if (request == PTRACE_DETACH)
+		tsk->ptrace &= ~PT_PTRACED;
+}
+
+void
+ptrace_single_step(void)
+{
+	unsigned long tmp;
+
+	tmp = get_stack_long(current, EFL_OFFSET) | TRAP_FLAG;
+	put_stack_long(current, EFL_OFFSET, tmp);
+	current->ptrace |= PT_PTRACED | PT_DTRACE;
+#ifdef CONFIG_MOSIX_DFSA
+	tell_process(current, DREQ_NOTUPTODATE);
+#endif /* CONFIG_MOSIX_DFSA */
+}
+
+void
+ptrace_getfpregs(struct user_i387_struct *to)
+{
+	struct task_struct *p = current;
+
+	unlazy_fpu(p);
+	if (!p->used_math)
+		load_empty_fpu(p);
+	get_fpregs(to, p);
+}
+
+void
+ptrace_getfpxregs(struct user_fxsr_struct *to)
+{
+	struct task_struct *p = current;
+
+	unlazy_fpu(p);
+	if (!p->used_math)
+		load_empty_fpu(p);
+	get_fpxregs(to, p);
+}
+
+void
+ptrace_setfpregs(struct user_i387_struct *from)
+{
+	struct task_struct *p = current;
+
+	clear_fpu(p);
+	p->used_math = 1;
+	set_fpregs(p, from);
+}
+
+void
+ptrace_setfpxregs(struct user_fxsr_struct *from)
+{
+	struct task_struct *p = current;
+
+	clear_fpu(p);
+	p->used_math = 1;
+	set_fpxregs(p, from);
+}
+#endif /* CONFIG_MOSIX */
+
+#ifdef CONFIG_MOSIX
+/*
+ * When a process starts a system call in PT_TRACESYS mode, it must run
+ * the full sequence: A=syscall_trace, B=the_system_call, C=syscall_trace.
+ * Since our process can migrate at any of those stages, we maintain 2 flags
+ * that tell us where to resume in the sequence.
+ * In the particular case of DTRACESYS1, the trace was already complete
+ * before the migration.  In the case of DTRACESYS2, the system-call was already
+ * complete before the migration and the code in "entry.S" prevents it from
+ * re-running.
+ */
+asmlinkage void
+syscall_trace(void)
+{
+	extern asmlinkage void do_syscall_trace(void);
+
+	switch(current->mosix.dflags & (DTRACESYS1|DTRACESYS2))
+	{
+		case 0:
+			current->mosix.dflags |= DTRACESYS1;
+			break;
+		case DTRACESYS1:
+			return;
+		case DTRACESYS2:
+		case DTRACESYS1|DTRACESYS2:
+			current->mosix.dflags &= ~(DTRACESYS1|DTRACESYS2);
+	}
+	if(current->mosix.dflags & DREMOTE)
+		mosix_remote_syscall_trace();
+	else
+		do_syscall_trace();
+}
+
+asmlinkage void do_syscall_trace(void)
+#else
 asmlinkage void syscall_trace(void)
+#endif /* CONFIG_MOSIX */
 {
 	if ((current->ptrace & (PT_PTRACED|PT_TRACESYS)) !=
 			(PT_PTRACED|PT_TRACESYS))
diff -Naur --exclude=CVS --exclude=configs linux/arch/i386/kernel/sys_i386.c linux-openmosix/arch/i386/kernel/sys_i386.c
--- linux/arch/i386/kernel/sys_i386.c	2003-08-25 13:44:39.000000000 +0200
+++ linux-openmosix/arch/i386/kernel/sys_i386.c	2004-02-05 10:50:55.000000000 +0100
@@ -22,6 +22,10 @@
 #include <asm/uaccess.h>
 #include <asm/ipc.h>
 
+#ifdef CONFIG_MOSIX_DFSA
+#include <linux/dfsa_interface.h>
+#endif /* CONFIG_MOSIX_DFSA */
+
 /*
  * sys_pipe() is the normal C calling standard for creating
  * a pipe. It's not the way Unix traditionally does this, though.
@@ -55,12 +59,20 @@
 			goto out;
 	}
 
+#ifdef CONFIG_MOSIX
+	error = do_mmap_pgoff_down(file, addr, len, prot, flags, pgoff);
+#else
 	down_write(&current->mm->mmap_sem);
 	error = do_mmap_pgoff(file, addr, len, prot, flags, pgoff);
 	up_write(&current->mm->mmap_sem);
+#endif /* CONFIG_MOSIX */
 
 	if (file)
 		fput(file);
+#ifdef CONFIG_MOSIX_DFSA
+	if(file && file_count(file) > 1)
+		dfsa_touch_file(fd);
+#endif /* CONFIG_MOSIX_DFSA */
 out:
 	return error;
 }
